<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.13.2.5.2.14 $
 * $Author: tora60 $
 * $Date: 2010/03/16 10:33:28 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Part of phpBB integration
 * Copyright (c) 2001 by
 * Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
 * Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
 * http://www.phpnuke.web.id
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * userlist in a seperated window
 */
function userslist()
{
    global $userdata, $Default_Theme, $prefix, $user_prefix, $excludedusers, $url_images, $module_name, $showAdminAsUser, $showAdminPrefix;
    $content = "";
    $totalmembers = 1;
    $winheigth = 200;
    $qry = "SELECT uid, uname FROM {$user_prefix}_users WHERE user_stat=1 ORDER BY uname;";
    $result = sql_query($qry); # alle user aus Tabelle auslesen
    while (list($uid, $uname) = sql_fetch_row($result)) {
        $content .= "$totalmembers &nbsp;<a href=\"#\" onclick=\"setname('$uname')\" style=\"text-decoration : none;\">$uname</a><br />\n";
        $totalmembers++; # Anzahl aller User hochzaehlen/ermitteln
    }
    $totalmembers = $totalmembers - 1; # Wieder einen User abziehen (war bei init 1)
    if ($totalmembers < 30) {
        $winheigth = $totalmembers * 30;
    }

    $ThemeSel = mxGetTheme();

    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html><head><title>" . _PMSUSERSLIST . "</title>";
    echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . _CHARSET . "\">\n";
    echo "<meta http-equiv=\"content-language\" content=\"" . _DOC_LANGUAGE . "\">\n";
    echo '<link rel="stylesheet" type="text/css" href="layout/style/style.css.php?t=' . $ThemeSel . '" />', "\n";
    echo '<link rel="stylesheet" type="text/css" href="themes/' . $ThemeSel . '/style/style.css" />', "\n";
    echo "<script type=\"text/javascript\">
/* <![CDATA[ */
	function resizewin(){
		window.resizeTo(240,$winheigth);
		window.moveTo((screen.width/2)-100,(screen.height/2)-($winheigth/2));
		window.focus();
	}
	function setname(thename) {
		opener.document.pmsubmit.to_user.value=thename;
	}
/* ]]> */
</script>";
    echo "</head><body class=\"allone popup\" onload='resizewin()'>";
    echo "<div class='content'>" . $content . "</div>";
    echo "</body></html>";
}

function get_userdata_from_id($userid)
{
    $userid = (int)$userid;
    $userdata = mxGetUserDataFromUid($userid);
    return (count($userdata)) ? $userdata : array("error" => "1");
}

function printsmilies()
{
    global $url_smiles, $smilie;
    $cols = 3;
    $count = 0;
    // asort($smilie);
    $break = (sizeof($smilie) / $cols);
    $rowspan = $cols + 1;
    $colspan = $break + 1;
    pmxHeader::add_script(PMX_JAVASCRIPT_PATH . 'unb_lib/unb_common.js');
    pmxHeader::add_script(PMX_JAVASCRIPT_PATH . 'unb_lib/unb_lib.js');
    echo "<table cellspacing=\"0\" cellpadding=\"2\" width=\"120\" class=\"smiliebar\">
	<tr><td rowspan=\"$colspan\" width=\"1\"></td><td colspan=\"$rowspan\"><font class=\"tiny\">" . _PMSCLICKSMILEBUTTONS . "</font></td></tr>
	<tr valign=\"top\"><td>";
    foreach ($smilie as $vals) {
        $count++;
        echo mxCreateImage($url_smiles . '/' . $vals[2], $vals[1] . ' ' . $vals[0], 0, ' onClick="UnbInsertText(\'' . $vals[0] . ' \')"');
        if (($count >= $break) && $count < sizeof($smilie)) {
            echo "</td><td>";
            $break = $break + $count;
            // $count=0;
        }
    }
    echo "</td></tr></table>";
}

function printbuddysmilies()
{
    global $url_smiles, $smilie;
    $cols = 1;
    $count = 0;
    // asort($smilie);
    $break = (sizeof($smilie) / $cols);
    $content = '';
    foreach ($smilie as $vals) {
        $count++;
        $content .= mxCreateImage($url_smiles . '/' . $vals[2], $vals[1] . ' ' . $vals[0], 0, ' onClick="UnbInsertText(\'' . $vals[0] . ' \')" style="cursor: pointer; margin: .2em .15em;"');
        if (($count >= $break) && $count < sizeof($smilie)) {
            $content .= '<br />';
            $break = $break + $count;
        }
    }
    return $content;
}

function putitems()
{
    global $prefix, $url_images;
    pmxHeader::add_script(PMX_JAVASCRIPT_PATH . 'unb_lib/unb_common.js');
    pmxHeader::add_script(PMX_JAVASCRIPT_PATH . 'unb_lib/unb_lib.js');
    echo '<table cellspacing="0" cellpadding="3" class="bbbar"><tr>';

    echo '<td>' . mxCreateImage($url_images . '/bb_url.gif', 'BBCode: ' . _BBURL, 0, 'onclick="UnbEditorDoCmd(event, \'url\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_email.gif', 'BBCode: ' . _BBEMAIL, 0, 'onclick="UnbEditorDoCmd(event, \'email\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_image.gif', 'BBCode: ' . _BBIMG, 0, 'onclick="UnbEditorDoCmd(event, \'img\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_bold.gif', 'BBCode: ' . _BBBOLD, 0, 'onclick="UnbEditorDoCmd(event, \'bold\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_italicize.gif', 'BBCode: ' . _BBITALIC, 0, 'onclick="UnbEditorDoCmd(event, \'italic\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_quote.gif', 'BBCode: ' . _BBQUOTE, 0, 'onclick="UnbEditorDoCmd(event, \'quote\'); return false;"') . '</td>';

    echo '</tr></table><div class="tiny">' . _PMSCLICKCODEBUTTONS . '</div>';
}

function pmValueToText($tmp)
{
    $tmp = str_replace(chr(9), "&nbsp;&nbsp;&nbsp;&nbsp;", $tmp);
    $tmp = str_replace(chr(10), "", $tmp);
    $tmp = str_replace(chr(13), " ", $tmp);
    $tmp = str_replace("<", "&lt;", $tmp);
    $tmp = str_replace(">", "&gt;", $tmp);
    $tmp = str_replace("\"", "&quot;", $tmp);
    $tmp = str_replace("'", "`", $tmp);
    $tmp = mxNL2BR($tmp);
    return $tmp;
}

function mxPmGetPictos($current)
{
    global $url_icons;
    $count = 0;

    $endings = array('gif', 'png', 'jpg', 'jpeg');
    $filelist = array();
    $tmp = (array)glob(str_replace(DS, '/', $url_icons . '/*'));
    foreach ($tmp as $image) {
        $info = pathinfo($image);
        if (isset($info['extension']) && in_array(strtolower($info['extension']), $endings)) {
            $filelist[$info['basename']] = $image;
        }
    }
    natcasesort($filelist);

    $pictos = '<table cellspacing="0" cellpadding="0" class="pictobar"><tr>';
    foreach ($filelist as $basename => $file) {
        if ($basename == $current || $file == $current) {
            $sel = ' checked="checked"';
        } else {
            $sel = '';
        }
        $pictos .= '<td><input type="radio" name="image" value="' . $basename . '"' . $sel . ' />' . mxCreateImage($file) . '</td>';
        $count++;
        if ($count >= 8) {
            $count = 0;
            $pictos .= '</tr><tr>';
        }
    }
    $pictos .= '</tr></table>';
    $pictos = str_replace('<tr></tr>', '', $pictos);
    return $pictos;
}

if (!function_exists('msg_smile')) {
    function msg_smile($x)
    {
        return $x;
    }
}
if (!function_exists('msg_desmile')) {
    function msg_desmile($x)
    {
        return $x;
    }
}
if (!function_exists('msg_bbencode')) {
    function msg_bbencode($x)
    {
        return $x;
    }
}
if (!function_exists('msg_bbdecode')) {
    function msg_bbdecode($x)
    {
        return $x;
    }
}
if (!function_exists('msg_bbencode_quote')) {
    function msg_bbencode_quote($x)
    {
        return $x;
    }
}

/**
 * returns the online-status from the poster, in messageview
 */
function get_onlinestatus($uname)
{
    global $prefix, $user_prefix, $cookie, $url_images;
    $isonline = mxIsUserOnline($uname);
    if (!$isonline && $cookie[1] != $uname) {
        $online = _PMSOFFLINE;
        $img = $url_images . '/td.gif';
    } else {
        $online = _PMSONLINE;
        $img = $url_images . '/tu.gif';
    }
    return '<br />' . mxCreateImage($img, $online);
}

/* ignore Funktion */
function mxPmIsRecipientIgnored($recipient, $uid = 0)
{
    global $user_prefix, $prefix;

    if (!mxModuleAllowed('Friendlist')) {
        return false;
    }

    @include(PMX_MODULES_DIR . DS . 'Friendlist/config.php');
    /* Admin und keine Grenze fuer Admin */
    if (MX_IS_ADMIN && empty($friendlist_admin)) {
        return false;
    }

    if (MX_IS_ADMIN && mxGetAdminPref('radminsuper') && empty($friendlist_godadmin)) {
        return false;
    }

    if (!$uid) {
        $userdata = mxGetUserData();
        $uid = $userdata['uid'];
    }

    $result = sql_query("select uid from {$prefix}_users_ignorelist where uid='" . intval($recipient['uid']) . "' AND ignoreid='" . intval($uid) . "'");
    return ($result && sql_num_rows($result));
}

/* PM Begrenzung */

function mxPmGetLimit()
{
    static $limit;
    if (!isset($limit)) {
        include(dirname(__file__) . "/inboxsize-conf.php");
    }
    return $limit;
}

function mxPmGrouplimit($group_id)
{
    $limit = mxPmGetLimit();

    $group = (!isset($limit[$group_id]['get']) || $limit[$group_id]['get'] == -1) ? 0 : $group_id;
    $limit['get'] = $limit[$group]['get'];

    $group = (!isset($limit[$group_id]['send']) || $limit[$group_id]['send'] == -1) ? 0 : $group_id;
    $limit['send'] = $limit[$group]['send'];

    return $limit;
}

function mxPmBoxstatus($uid = 0)
{
    global $prefix;

    $limit = mxPmGetLimit();
    $uid = intval($uid);
    if ($uid) {
        /* wenn uid uebergeben, dann die Daten aus der USertabelle auslesen */
        $userdata = mxGetUserDataFromUid($uid);
    } else {
        /* ansonsten, die Daten des aktuellen Users verwenden */
        $userdata = mxGetUserData();
        $uid = $userdata['uid'];
    }

    /* wenn diese uid bereits abgerufen wurde, statische Daten zurueckgeben ;) */
    static $static;
    if (isset($static[$uid])) {
        return $static[$uid];
    }

    switch (true) {
        /* Admin und keine Grenze fuer Admin */
        case (MX_IS_ADMIN && empty($limit['admin'])):
        /* God-Admin und keine Grenze fuer God-Admin */
        case (MX_IS_ADMIN && mxGetAdminPref('radminsuper') && empty($limit['godadmin'])):
            $out['get']['limit'] = 0;
            $out['send']['limit'] = 0;
            break;
        default:
            $tmp = mxPmGrouplimit($userdata['user_ingroup']);
            $out['get']['limit'] = $tmp['get'];
            $out['send']['limit'] = $tmp['send'];
    }
    /* Anzahl der empfangenen PM */
    $result = sql_query("SELECT Count(msg_id) FROM  `{$prefix}_priv_msgs` WHERE to_userid=" . intval($uid));
    list($out['get']['box']) = sql_fetch_row($result);

    /* Anzahl der PM im Postausgang */
    $result = sql_query("SELECT Count(msg_id) FROM  `{$prefix}_priv_msgs_send` WHERE from_userid=" . intval($uid));
    list($out['send']['box']) = sql_fetch_row($result);

    /* noch freie Nachrichten */
    if (($out['get']['limit'])) {
        $out['get']['free'] = $out['get']['limit'] - $out['get']['box'];
        if ($out['get']['free'] < 0) {
            $out['get']['free'] = 0;
        }
    } else {
        /* ohne Limit: 0 */
        $out['get']['free'] = 0;
    }

    if (($out['send']['limit'])) {
        $out['send']['free'] = $out['send']['limit'] - $out['send']['box'];
        if ($out['send']['free'] < 0) {
            $out['send']['free'] = 0;
        }
    } else {
        /* ohne Limit: 0 */
        $out['send']['free'] = 0;
    }

    /* PostEingang voll? */
    $out['get']['error'] = ($out['get']['limit'] && $out['get']['box'] >= $out['get']['limit']) ? 1 : '';
    /* PostAusgang voll? */
    $out['send']['error'] = ($out['send']['limit'] && $out['send']['box'] >= $out['send']['limit']) ? 1 : '';

    /* Statische Daten dieser uid zwischenspeichern */
    $static[$uid] = $out;
    // mxDebugFuncVars($out);
    /* Rueckgabe */
    return $out;
}

/* Email bei neuer PN wenn User offline ist */
function mxPmMailNote($recipient, $sender)
{
    $subject = _PMEMAILSUB . PMX_HOME_URL;
    $message = _HELLO . " " . $recipient['uname'] . ",\n" . _PMEMAIL . PMX_HOME_URL . _PMEMAIL1 . " " . $sender['uname'] . " " . _PMEMAIL2 . PMX_HOME_URL . "/modules.php?name=" . $GLOBALS['module_name'] . _PMEMAIL3 . PMX_HOME_URL . "/modules.php?name=Your_Account&op=edithome";
    if (!$recipient['user_online'] && (!empty($recipient['user_pm_mail']))) {
        // mxDebugFuncVars($message); exit;
        mxMail($recipient['email'], $subject, $message, $GLOBALS['adminmail'], "text", "PM-Mail");
    }
}

?>
