<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.21.2.11.2.27 $
 * $Author: tora60 $
 * $Date: 2010/08/27 07:01:36 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Part of phpBB integration
 * Copyright (c) 2001 by
 * Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
 * Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
 * http://www.phpnuke.web.id
 */

defined('mxMainFileLoaded') or die('access denied');

function msgindex($uid)
{
    global $prefix, $user_prefix, $module_name, $url_smiles, $url_icons, $subjectdefaulticon, $url_images, $pagesize, $url_button;
    global $popupwidth, $poptableborder;

    /* Gesamtzahl der PM'S berechnen, fuer Pager */
    $result = sql_query("SELECT COUNT(to_userid) FROM `{$prefix}_priv_msgs` where to_userid = " . intval($uid));
    list($allrows) = sql_fetch_row($result);

    /* Limit fuer Pager berechnen */
    $pagesize = (empty($pagesize) || intval($pagesize) < 5) ? 5 : intval($pagesize);
    $page = (empty($_REQUEST['page']) || intval($_REQUEST['page']) < 1) ? 1 : intval($_REQUEST['page']);
    $maxpages = ceil($allrows / $pagesize);
    if ($page > $maxpages) {
        $page = $maxpages;
    }
    $min = $pagesize * ($page - 1);
    if ($min < 1) {
        $min = 0;
    }

    /* Datensaetze auslesen */
    $result = sql_query("SELECT {$prefix}_priv_msgs.*, UNIX_TIMESTAMP(msg_time) as msgtimestamp, {$user_prefix}_users.uname as fromname
                        FROM {$prefix}_priv_msgs
                        LEFT JOIN {$user_prefix}_users
                        ON {$prefix}_priv_msgs.from_userid = {$user_prefix}_users.uid
                        WHERE to_userid=" . $uid . "
                        ORDER BY msg_time DESC
                        LIMIT " . $min . ", " . $pagesize);
    if (!$result) {
        return prvmsgerror(_ERRMSGDATABASE);
    }
    if (!$total_messages = sql_num_rows($result)) {
        $havemessages = 0;
    } else {
        $havemessages = 1;
        pmxHeader::add_script(PMX_MODULES_PATH . $module_name . '/javascript.js');
        pmxHeader::add_jquery('ui/jquery-ui-pmx-core.min.js', 'ui/jquery.ui.tooltip.min.js');

        ?>
<script type="text/javascript">
/* <![CDATA[ */
$(document).ready(function() {
    $('.tooltip-info').tooltip();
});
/* ]]> */
</script>

<?php
    }
    $count = 0;
    echo "<form name=\"prvmsg\" method=\"post\" action=\"modules.php?name=" . $module_name . "\">\n";
    echo "<input type=\"hidden\" name=\"name\" value=\"" . $module_name . "\" />\n";

    echo "<div><br />&nbsp;&nbsp;" . mxCreateImage("$url_images/inbox.png", _ESENTPMS) . "<b>&nbsp;&nbsp;" . _PMIN . "</b><br /><br /></div> ";
    echo "<table cellspacing=\"1\" cellpadding=\"1\" width=\"100%\" class=\"bgcolor2\">\n";
    if (!$havemessages) {
        echo "<tr class=\"bgcolor3\">\n<td colspan=\"6\" align=\"center\"><br /><br /><br /><b>" . _PMSDONTHAVESOME . "</b><br /><br /><br /></td>\n</tr>\n";
    } else {
        echo "<tr class=\"bgcolor2\">\n"
         . "<td colspan=\"5\" class=\"bgcolor2\" align=\"left\"><font class=\"content\"><b>&nbsp;&nbsp;" . _EMPFPMS . "</b></font><br /></td></tr>\n";
        echo "<tr class=\"bgcolor2\">\n"
         . "<td></td>\n"
         . "<td align=\"center\" class=\"bgcolor2\">" . mxCreateImage($url_images . '/down.gif', _PMSMSGSTATUS) . "</td>"
         . "<td align=\"center\" class=\"bgcolor2\">&nbsp;</td>\n"
         . "<td><font class=\"content\"><b>" . _PMSFROM . "</b></font></td>\n"
         . "<td align=\"center\"><font class=\"content\"><b>" . _PMSSUBJECT . "</b></font></td>\n"
         . "<td align=\"center\"><font class=\"content\"><b>" . _PMSDATE . "</b></font></td>\n"
         . "</tr>\n";
        while ($row = sql_fetch_array($result)) {
            if (empty($row["fromname"])) {
                $row["fromname"] = '';
            }
            if (empty($row["msg_image"])) {
                $row["msg_image"] = $subjectdefaulticon;
            }
            $postedtime = mx_strftime(_PMSTIMESTRING, $row["msgtimestamp"]);
            $row["subject"] = strip_tags($row["subject"]);
            $row["subject"] = msg_smile($row["subject"]);

            $row["msg_text"] = strip_tags($row["msg_text"], "<img><br><hr><b><i>");
            // $row["msg_text"] = str_replace(array('&#41;','&#124;'),array(')','|'),$row["msg_text"]); /// macht mxSecureValue() rckgngig
            $row["msg_text"] = pmPrepDisplay($row["msg_text"]);

            $tooltip = pmValueToText($row["msg_text"]);

            echo "<tr><td class=\"bgcolor1\" width=\"2%\" align=\"center\"><input type=\"checkbox\" onclick=\"CheckCheckAll();\" name=\"msg_id[$count]\" value=\"" . (int)$row["msg_id"] . "\" style=\"background-color: transparent;\" />";
            echo "</td>\n";
            echo "<td width=\"5%\" align=\"center\" class=\"bgcolor1\">";
            if ($row["read_msg"] == 1) {
                echo mxCreateImage($url_images . '/read.gif', _PMSREAD);
            } else {
                echo mxCreateImage($url_images . '/unread.gif', _PMSNOTREAD);
            }
            echo "</td>\n";
            echo '<td class="bgcolor3 align-center" width="5%"><a href="modules.php?name=' . $module_name . '&amp;op=read&amp;id=' . $row['msg_id'] . '">' . mxCreateImage($url_icons . '/' . $row['msg_image']) . '</a></td>';
            echo "<td class=\"bgcolor1\" width=\"10%\"><font class=\"content\">" . mxCreateUserprofileLink($row["fromname"]) . "</font></td>\n";
            echo "<td class=\"bgcolor3\"><a href=\"modules.php?name=$module_name&amp;op=read&amp;id=" . $row["msg_id"] . "\" class=\"tooltip-info\" title=\"" . $tooltip . "\"><font class=\"tiny\">" . $row["subject"] . "</font></a></td>\n";
            echo "<td class=\"bgcolor1\" align=\"center\" width=\"18%\"><font class=\"tiny\">$postedtime</font></td>\n";
            echo "</tr>\n";
            $count++;
        }

        if ($havemessages) {
            echo "<tr class=\"bgcolor2\">\n"

             . "<td class=\"bgcolor2\" align=\"center\"><input name=\"allbox\" onclick=\"CheckAll();\" type=\"checkbox\" value=\"" . _PMSCHECKALL . "\" style=\"background-color: transparent;\" /></td>\n"
             . "<td><font class=\"content\">" . _PMALL . "</font></td>\n"
             . "<td></td>\n"
             . "<td></td>\n"
             . "<td></td>\n"
             . "<td align=\"right\"><font class=\"content\">" . _SAVEPMSS . "&nbsp;<a href=\"modules.php?name=$module_name&amp;op=speichern\">" . mxCreateImage("$url_images/disk.png", _SAVEPMS) . "</a>&nbsp;&nbsp;</font></td>\n"
             . "</tr>\n";
        }
    }

    echo "<tr class=\"bgcolor2\">\n<td colspan=\"6\">";
    if ($havemessages) {
        echo "&nbsp;" . mxCreateImage("$url_images/arrow_top.gif") . _PMDEL . "&nbsp;<input type=\"image\" src=\"$url_images/email_delete.png\" name=\"delete_messages\" value=\"delete_messages\" style=\"background-color: transparent; border: none;\" alt=\"" . _PMSDELETE . "\" title=\"" . _PMSDELETE . "\">";
        echo "<input type=\"hidden\" name=\"total_messages\" value=\"" . (int)$total_messages . "\" />";
        echo "<input type=\"hidden\" name=\"op\" value=\"delete_messages\"> ";
        echo "<br /><br />&nbsp;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=send\">" . mxCreateImage("$url_images/mail_new.png", _PMSPRIVATEMESSAGESEND) . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;op=send\">" . _PMSPRIVATEMESSAGESEND . "</a> ";
        echo "&nbsp;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=sendmsg\">" . mxCreateImage("$url_images/outbox.png", _ASENTPMS) . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;op=sendmsg\">" . _ASENTPMS . "</a>";
        echo pm_pager($page, $allrows);
    } else {
        echo "<br /><br />&nbsp;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=send\">" . mxCreateImage("$url_images/mail_new.png", _PMSPRIVATEMESSAGESEND) . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;op=send\">" . _PMSPRIVATEMESSAGESEND . "</a> ";
        echo "&nbsp;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=sendmsg\">" . mxCreateImage("$url_images/outbox.png", _ASENTPMS) . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;op=sendmsg\">" . _ASENTPMS . "</a><br /><br />";
    }
    echo "</td>\n</tr>\n</table>\n</form>";
}

function prvmsgerror($error_msg)
{
    echo "<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">"
     . "<tr class=\"bgcolor2\" align=\"center\"><td><br />"
     . "<center><font class=\"title\"><b>" . _PMSGERROR . "</b></font><br /><br />"
     . "<div class=\"warning\"><br />$error_msg<br /><br /></div>"
     . "<br /><br />" . _GOBACK . "<br /></center></td></tr></table>";
}

function readmessage($id, $uid)
{
    global $prefix, $user_prefix, $module_name, $url_smiles, $url_icons, $url_images, $blankavatar;
    global $allow_bbcode, $allow_html, $subjectdefaulticon;
    global $url_button;
    list($id, $uid) = mxForceInteger($id, $uid); // by AE
    $qry = "SELECT {$prefix}_priv_msgs.*, UNIX_TIMESTAMP(msg_time) as msgtimestamp FROM {$prefix}_priv_msgs WHERE (to_userid=$uid) and (msg_id=$id);";
    $result = sql_query($qry);
    if (!$result) {
        return prvmsgerror(_ERRMSGDATABASE);
    }
    $row = sql_fetch_array($result);
    if (!$row["msg_id"]) {
        msgindex($uid);
    } else {
        $posterdata = get_userdata_from_id($row["from_userid"]);
        $postedtime = mx_strftime(_PMSTIMESTRING, $row["msgtimestamp"]);

        $replymsg = pmUndoPrepDisplay($row['msg_text']);
        $replymsg = "[quote][i]" . _ON . " " . $postedtime . ", " . _PMSWROTE . " " . $posterdata['uname'] . ":[/i]\n" . $replymsg . "\n[/quote]\n";

        $row["msg_text"] = pmPrepDisplay($row["msg_text"]);
        if (empty($row["msg_image"])) {
            $row["msg_image"] = $subjectdefaulticon;
        }

        $qry = "SELECT msg_id FROM {$prefix}_priv_msgs WHERE to_userid=$uid and msg_time>'" . $row["msg_time"] . "' and msg_id<>'" . $row["msg_id"] . "' and (from_userid is not null) order by msg_time asc LIMIT 0,1";
        list($next) = sql_fetch_row(sql_query($qry));
        $qry = "SELECT msg_id FROM {$prefix}_priv_msgs WHERE to_userid=$uid and msg_time<'" . $row["msg_time"] . "' and msg_id<>'" . $row["msg_id"] . "' and (from_userid is not null) order by msg_time desc LIMIT 0,1";
        list($previous) = sql_fetch_row(sql_query($qry));
        $qry = "UPDATE {$prefix}_priv_msgs SET read_msg=1 WHERE msg_id=" . $row["msg_id"];
        $result = sql_query($qry);
        if (!$result) {
            return prvmsgerror(_ERRMSGDATABASE);
        }

        if (empty($posterdata["user_sig"])) {
            $rowspan = "2";
        } else {
            $rowspan = "3";
            $posterdata["user_sig"] = pmPrepDisplay(pmxSigBbCode($posterdata["user_sig"]));
        }

        echo "<div><br />&nbsp;&nbsp;<a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/inbox.png", _ESENTPMS) . "</a><b>&nbsp;&nbsp;<a href=\"modules.php?name=$module_name\">" . _PMIN . "</a></b><br /><br /></div> ";
        echo"<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">";
        echo "<tr class=\"bgcolor1\"><td colspan=\"2\"><font class=\"content\">"
         . "<a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/privatemessages.png", _PMSRETURNTOPMSG) . "</a> &nbsp;";
        if ($previous) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=read&amp;id=$previous\">" . mxCreateImage("$url_images/left.gif", _PMSPREVIOUS) . "</a> &nbsp;";
        } else {
            echo mxCreateImage("$url_images/left.gif", _PMSPREVIOUS) . " &nbsp;";
        }
        if ($next) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=read&amp;id=$next\">" . mxCreateImage("$url_images/right.gif", _PMSNEXT) . "</a>";
        } else {
            echo mxCreateImage("$url_images/right.gif", _PMSNEXT);
        }
        echo "</font></td></tr>"
         . "<tr class=\"bgcolor2\">"
         . "<td colspan=\"2\"><font class=\"title\">" . _PMSPRIVATEMESSAGE . ": &nbsp;&nbsp;<b><i>" . msg_smile($row["subject"]) . "</i></b></font></td>"
         . "</tr>"
         . "<tr class=\"bgcolor3\">\n"
         . "<td valign=\"top\" rowspan=\"" . $rowspan . "\" width=\"20%\">" . _PMSFROM . ": <b>" . mxCreateUserprofileLink($posterdata["uname"]) . "</b><br /><br />\n";

        /* aktuelles Benutzerbild ermitteln */
        $pici = load_class('Userpic', $posterdata);
        $ug_img = $pici->getHtml('small');
        if ($ug_img) {
            echo $ug_img . '<br />';
        }

        echo '<div class="tiny">';
        if ($posterdata['user_online']) {
            echo mxCreateImage($url_images . '/tu.gif', _PMSONLINE) . '&nbsp;' . _PMSONLINE;
        } else {
            echo mxCreateImage($url_images . '/td.gif', _PMSOFFLINE) . '&nbsp;' . _PMSOFFLINE;
        }
        echo "</div></td>"
         . '<td width="80%" height="10" valign="top">' . mxCreateImage($url_icons . '/' . $row['msg_image']) . '&nbsp;<font class="content">' . _PMSSENT . ': ' . $postedtime . '</font></td></tr>'
         . "<tr class=\"bgcolor1\"><td width='80%' height='80' valign='top'>" . $row["msg_text"] . "<br /><br /></td></tr>";

        if (!empty($posterdata["user_sig"])) {
            echo "<tr class=\"bgcolor3\"><td width='80%' height='10'><div class=\"tiny\">" . $posterdata["user_sig"] . "</div></td></tr>\n";
        }

        echo "<tr class=\"bgcolor2\"><td colspan=\"2\">"
         . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>"
         . "<td><a href=\"modules.php?name=$module_name&amp;op=delete&amp;msg_id=" . $row["msg_id"] . "\">" . mxCreateImage("$url_images/email_delete.png", _PMSDELETE) . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;op=delete&amp;msg_id=" . $row["msg_id"] . "\">" . _PMSDELETE . "</a>\n</td>\n"
         . "<td align=\"right\">"
         . "<a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/privatemessages.png", _PMSRETURNTOPMSG) . "</a> &nbsp;";
        if ($previous) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=read&amp;id=$previous\">" . mxCreateImage("$url_images/left.gif", _PMSPREVIOUS) . "</a> &nbsp;";
        } else {
            echo mxCreateImage("$url_images/left.gif", _PMSPREVIOUS) . " &nbsp;";
        }
        if ($next) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=read&amp;id=$next\">" . mxCreateImage("$url_images/right.gif", _PMSNEXT) . "</a>";
        } else {
            echo mxCreateImage("$url_images/right.gif", _PMSNEXT);
        }
        echo "</td></tr></table>"
         . "</td></tr></table>";
        echo "<form action=\"modules.php?name=" . $module_name . "\" method=\"post\" name=\"pmsubmit\">";
        echo "<input type=\"hidden\" name=\"name\" value=\"" . $module_name . "\" />\n";
        echo "<input type=\"hidden\" name=\"op\" value=\"submit\" />\n";
        echo "<br /><table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">"
         . "<tr class=\"bgcolor2\">"
         . "<td colspan=\"2\"><font class=\"title\"><b>" . $posterdata["uname"] . "&nbsp;" . _PMSREPLY . ":</b></font></td>"
         . "</tr>";
        if (MX_IS_ADMIN) {
            echo "<tr>"
             . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSTOALL1 . ":</b></td>"
             . "<td class=\"bgcolor1\"><input type='checkbox' name='to_all' value='1' /> <span class=\"tiny\">" . _PMSTOALL2 . "</span></td>"
             . "</tr>";
        }
        echo "<tr>"
         . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSSUBJECT . ":</b></td>"
         . "<td class=\"bgcolor1\"><input type=\"text\" name=\"subject\" value=\"" . mxEntityQuotes(msg_desmile($row["subject"])) . "\" size=\"50\" maxlength=\"100\" /></td>"
         . "</tr>"
         . "<tr valign=\"top\">"
         . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSMESSAGEICON . ":</b></td>"
         . "<td class=\"bgcolor1\">" . mxPmGetPictos($row["msg_image"]) . "</td>"
         . "</tr>"
         . "<tr valign=\"top\">"
         . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSMESSAGE . ":</b><br /><br />"
         . "<font class=\"tiny\">";
        if ($allow_html == 1) {
            echo _PMSHTML . ": " . _PMSPMON . "<br />\n";
        } else {
            echo _PMSHTML . ": " . _PMSOFF . "<br />\n";
        }
        if ($allow_bbcode == 1) {
            echo _PMSBBCODELINK . _PMSBBCODE . "</a>: " . _PMSPMON . "<br />\n";
        } else {
            echo _PMSBBCODE . ": " . _PMSOFF . "<br />\n";
        }
        echo "</font></td>"
         . "<td class=\"bgcolor1\">"
         . "<table cellspacing=\"0\" cellpadding=\"0\"><tr>"
         . "<td><textarea name=\"message\" id=\"message\" rows=\"10\" cols=\"45\">" . htmlspecialchars($replymsg) . "</textarea></td>"
         . "<td>";
        if ($allow_bbcode == 1) {
            printsmilies();
        }
        echo "</td></tr></table>";
        if ($allow_bbcode == 1) {
            putitems();
            echo '
<script type="text/javascript">
/* <![CDATA[ */
    var textbox = getel("message");
    UnbGlobalRegisterKeyHandler(13, 0, 2);
/* ]]> */
</script>
';
        }
        echo "</td></tr>"
         . "<tr valign=\"top\">"
         . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSSAVE . ":</b><br /><br /></td>"
         . "<td class=\"bgcolor1\"><input type=\"checkbox\" checked=\"checked\" name=\"notsave\" value=\"1\" style=\"background-color: transparent;\"> <span class=\"tiny\">" . _NOTSAVEPMS . "</span></td></tr>"
         . "<tr><td class=\"bgcolor1\" colspan=\"2\" align=\"center\">\n"
         . "<input type=\"hidden\" name=\"to_user\" value=\"" . mxEntityQuotes($posterdata["uname"]) . "\" />"
         . "<input type=\"hidden\" name=\"msg_id\" value=\"" . (int)$row["msg_id"] . "\" />\n"
         . "<input type=\"submit\" name=\"submit\" value=\"" . _PMSSUBMIT . "\" />&nbsp;\n"
         . "<input type=\"reset\" value=\"" . _PMSCLEAR . "\" />\n"
         . "</td></tr>"
         . "</table>"
         . "</form>";
    }
}

function sendmessage($msg_id, $uid, $to_user = "")
{
    global $allow_bbcode, $allow_html;
    global $prefix, $user_prefix, $module_name, $url_smiles, $url_button, $subjectdefaulticon, $url_images;

    $msg_id = intval($msg_id);
    $count = 0;
    $userlistlink = "[&nbsp;<a style=\"cursor: pointer;\" onclick=\"window.open('modules.php?name=$module_name&amp;op=userslist','pmuserslist','left=200, top=200, width=240,height=200,toolbar=no,location=no,directories=no,statusbar=no,status=no,menubar=no,scrollbars=yes,resizable=yes,copyhistory=no'); return false;\">" . _PMSUSERSLIST . "</a>&nbsp;]";
    if ($msg_id) {
        $qry = "SELECT msgs.msg_image, msgs.subject, msgs.to_userid, UNIX_TIMESTAMP(msg_time), msgs.msg_text, fromuser.uname "
         . "FROM {$prefix}_priv_msgs AS msgs LEFT JOIN {$user_prefix}_users AS fromuser ON msgs.from_userid = fromuser.uid "
         . "WHERE ((to_userid=$uid) AND (msg_id=$msg_id) and (from_userid is not null));";
        $result = sql_query($qry);
        if (!$result) {
            return prvmsgerror(_ERRMSGDATABASE);
        }
        list($msg_image, $subject, $to_userid, $msg_time, $msg_text, $to_user) = sql_fetch_row($result);
        $msg_time = mx_strftime(_PMSTIMESTRING, $msg_time);
        if (!$msg_image) {
            $msg_image = $subjectdefaulticon;
        }
        $subject = _PMSRE . ": " . msg_desmile($subject);
        $subject = str_replace("" . _PMSRE . ": " . _PMSRE . ": ", _PMSRE . ": ", $subject);
        $msg_text = pmUndoPrepDisplay($msg_text);
        $msg_text = "[quote][i]" . _ON . " " . $msg_time . ", " . _PMSWROTE . " " . $to_user . ":[/i]\n" . $msg_text . "\n[/quote]\n";
    } else {
        if (is_numeric($uid) && empty($to_user)) {
            $qry = "SELECT uid, uname from {$user_prefix}_users where uid=$uid and user_stat=1 and uname<>'" . mxAddSlashesForSQL($GLOBALS['anonymous']) . "';";
            $result = sql_query($qry);
            list($uid, $to_user) = sql_fetch_row($result);
        } else {
            $to_user = (empty($to_user)) ? $uid : $to_user;
        }
        $msg_image = $subjectdefaulticon;
        $subject = "";
        $msg_text = "";
    }
    echo "<form action=\"modules.php?name=" . $module_name . "\" method=\"post\" name=\"pmsubmit\">";
    echo "<input type=\"hidden\" name=\"name\" value=\"" . $module_name . "\" />\n";
    echo "<input type=\"hidden\" name=\"op\" value=\"submit\" />\n";

    echo "<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">"
     . "<tr class=\"bgcolor2\">"
     . "<td colspan=\"2\" align=\"right\"><div style=\"float:left;\"><font class=\"title\"><b>" . _PMSPRIVATEMESSAGESEND . "</b></font></div>"
     . "<div style=\"float:right;\"><a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/privatemessages.png", _PMSRETURNTOPMSG) . "</a></div></td>"
     . "</tr>"
     . "<tr>"
     . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSTO . ":</b></td>"
     . "<td class=\"bgcolor1\"><input name=\"to_user\" size=\"26\" maxlength=\"25\" value=\"" . mxEntityQuotes($to_user) . "\" />&nbsp;&nbsp;&nbsp;" . $userlistlink . "</td>"
     . "</tr>";
    if (MX_IS_ADMIN) {
        echo "<tr>"
         . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSTOALL1 . ":</b></td>"
         . "<td class=\"bgcolor1\"><input type='checkbox' name='to_all' value='1' /> <span class=\"tiny\">" . _PMSTOALL2 . "</span></td>"
         . "</tr>";
    }
    echo "<tr>"
     . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSSUBJECT . ":</b></td>"
     . "<td class=\"bgcolor1\"><input type=\"text\" name=\"subject\" value=\"" . mxEntityQuotes($subject) . "\" size=\"50\" maxlength=\"100\" /></td>"
     . "</tr>"
     . "<tr valign=\"top\">"
     . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSMESSAGEICON . ":</b></td>"
     . "<td class=\"bgcolor1\">" . mxPmGetPictos($msg_image) . "</td>"
     . "</tr>"
     . "<tr valign=\"top\">"
     . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSMESSAGE . ":</b><br /><br />"
     . "<font class=\"tiny\">";
    if ($allow_html == 1) {
        echo _PMSHTML . ": " . _PMSPMON . "<br />\n";
    } else {
        echo _PMSHTML . ": " . _PMSOFF . "<br />\n";
    }
    if ($allow_bbcode == 1) {
        echo _PMSBBCODELINK . _PMSBBCODE . "</a>: " . _PMSPMON . "<br />\n";
    } else {
        echo _PMSBBCODE . ": " . _PMSOFF . "<br />\n";
    }
    echo "</font></td>"
     . "<td class=\"bgcolor1\">"
     . "<table cellspacing=\"0\" cellpadding=\"0\"><tr>"
     . "<td><textarea name=\"message\" id=\"message\" rows=\"10\" cols=\"45\">" . htmlspecialchars($msg_text) . "</textarea></td>"
     . "<td>";
    if ($allow_bbcode == 1) {
        printsmilies();
    }
    echo "</td></tr></table>";
    if ($allow_bbcode == 1) {
        putitems();
        echo '
<script type="text/javascript">
/* <![CDATA[ */
    var textbox = getel("message");
    UnbGlobalRegisterKeyHandler(13, 0, 2);
/* ]]> */
</script>
    ';
    }
    echo "</td></tr>"
     . "<tr valign=\"top\">"
     . "<td width=\"25%\" class=\"bgcolor3\"><b>" . _PMSSAVE . ":</b><br /><br /></td>"
     . "<td class=\"bgcolor1\"><input type='checkbox' checked='checked' name='notsave' value='1' style='background-color: transparent;'> <span class='tiny'>" . _NOTSAVEPMS . "</span></td></tr>"
     . "<tr><td class=\"bgcolor1\" colspan=\"2\" align=\"center\">\n"
     . "<input type=\"hidden\" name=\"msg_id\" value=\"" . (int)$msg_id . "\" />\n"
     . "<input type=\"submit\" name=\"submit\" value=\"" . _PMSSUBMIT . "\" />&nbsp;\n"
     . "<input type=\"reset\" value=\"" . _PMSCLEAR . "\" />\n"
     . "&nbsp;<input type=\"submit\" name=\"cancel\" value=\"" . _PMSCANCELSEND . "\" />\n"
     . "</td></tr>"
     . "</table>"
     . "</form>"
     . '<br />';
}

function cancelsubmit($msg_id, $uid)
{
    list($msg_id, $uid) = mxForceInteger($msg_id, $uid);
    if ($msg_id) {
        readmessage($msg_id, $uid);
    } else {
        msgindex($uid);
    }
}

function submitmessage($arrpostdata, $uid)
{
    global $prefix, $user_prefix, $module_name, $refresh;

    /* Senderdaten */
    $sender = mxGetUserData();

    if (empty($arrpostdata["to_user"]) && empty($arrpostdata["to_all"]) || (!empty($arrpostdata["to_all"]) && !MX_IS_ADMIN)) {
        return prvmsgerror(_ERRMSGNOUSER);
    }

    if (empty($arrpostdata["to_all"])) {
        /* Empfaengerdaten */
        $recipient = mxGetUserDataFromUsername($arrpostdata['to_user']);

        /* kein gueltiger Empfaenger */
        if (empty($recipient['uid'])) {
            return prvmsgerror(_PMSUSERNOTINDB);
        }
        /* ignore Funktion */
        if (mxPmIsRecipientIgnored($recipient['uid'], $uid)) {
            return prvmsgerror($recipient['uname'] . ' ' . _NOMESSAGE);
        }

        /* PM Begrenzung */
        $status = mxPmBoxstatus($recipient['uid']);
        $getbox_recipient = $status['get'];
        if ($getbox_recipient['limit'] && $getbox_recipient['error']) {
            return prvmsgerror(_EMPFPMBOXVOLL);
        }
        /* Ende PM Begrenzung */
    }

    /* PM Begrenzung */
    $status = mxPmBoxstatus();
    $sendbox = $status['send'];
    if ($sendbox['limit'] && $sendbox['error']) {
        return prvmsgerror(_SENTPMBOXVOLL);
    }
    /* Ende PM Begrenzung */

    $arrpostdata["subject"] = strip_tags($arrpostdata["subject"]);
    if (!($arrpostdata["subject"])) {
        $arrpostdata["subject"] = _PMNOSUBJECT;
    }
    if (!($arrpostdata["message"])) {
        return prvmsgerror(_ERRMSGNOMESSAGE);
    }
    if (!isset($arrpostdata["image"])) {
        $arrpostdata["image"] = '';
    }
    $qry1 = "INSERT INTO {$prefix}_priv_msgs (msg_image, subject, from_userid, to_userid, msg_time, msg_text) ";
    if (empty($arrpostdata["to_all"])) {
        $qry1 .= "VALUES ('" . mxAddSlashesForSQL($arrpostdata["image"]) . "', '" . mxAddSlashesForSQL($arrpostdata["subject"]) . "', " . intval($uid) . ", " . intval($recipient['uid']) . ", now(), '" . mxAddSlashesForSQL($arrpostdata["message"]) . "')";
        if (!sql_query($qry1)) {
            return prvmsgerror(_ERRMSGNOSUBMIT . ' (1)');
        }

        /* Gesendete PMS speichern */
        if (!empty($arrpostdata["notsave"])) {
            $newid = sql_insert_id();
            $qry = "INSERT INTO {$prefix}_priv_msgs_send (msg_id, msg_image, subject, from_userid, to_userid, msg_time, msg_text)
                             VALUES (" . intval($newid) . ", '" . mxAddSlashesForSQL($arrpostdata["image"]) . "', '" . mxAddSlashesForSQL($arrpostdata["subject"]) . "', " . intval($uid) . ", " . intval($recipient['uid']) . ", now(), '" . mxAddSlashesForSQL($arrpostdata["message"]) . "')";
            sql_query($qry);
        }
        /* Ende Gesendete PMS speichern */

    } else {
        if (MX_IS_ADMIN) {
            $i = 0;
            $result = sql_query("select uid from {$user_prefix}_users where user_stat=1");
            while (list($to_userid) = sql_fetch_row($result)) {
                $qry2 = $qry1 . " VALUES ('" . mxAddSlashesForSQL($arrpostdata["image"]) . "', '" . mxAddSlashesForSQL($arrpostdata["subject"]) . "', " . intval($uid) . ", " . intval($to_userid) . ", now(), '" . mxAddSlashesForSQL($arrpostdata["message"]) . "')";
                $result2 = sql_query($qry2);
                if ($result2) $i++;
            }
        }
    }

    /* Email bei neuer PN wenn User offline ist */
    if (empty($arrpostdata["to_all"])) {
        mxPmMailNote($recipient, $sender);
    }
    /* Ende, Email bei neuer PN wenn User offline ist */

    pmxHeader::add('<meta http-equiv="Refresh" content="' . ((isset($i)) ? ($refresh * 4) : $refresh) . ';URL=modules.php?name=' . $module_name . '">');

    echo "<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">"
     . "<tr class=\"bgcolor2\">"
     . "<td><br /><center>" . _PMSMSGPOSTED . " " . ((isset($i)) ? " (" . $i . " User)" : "") . "<br /><a href=\"modules.php?name=$module_name\">" . _PMSRETURNTOPMSG . "</a></center><br /></td>"
     . "</tr></table>";
}

function deletemessage($msg_id, $uid)
{
    global $prefix, $user_prefix, $module_name, $refresh, $url_button, $url_images;
    list($msg_id, $uid) = mxForceInteger($msg_id, $uid);
    $qry = "SELECT msg_time FROM {$prefix}_priv_msgs WHERE (to_userid=$uid) and (msg_id=$msg_id) and (from_userid is not null) LIMIT 0,1";
    list($time) = sql_fetch_row(sql_query($qry));
    $qry = "SELECT msg_id FROM {$prefix}_priv_msgs WHERE (to_userid=$uid) and (msg_time>'$time') and (msg_id<>$msg_id) and (from_userid is not null) order by msg_time asc LIMIT 0,1";
    list($nextid) = sql_fetch_row(sql_query($qry));
    $qry = "DELETE FROM {$prefix}_priv_msgs WHERE (msg_id=$msg_id) AND (to_userid=$uid) or (from_userid is null)";
    if (!sql_query($qry)) {
        return prvmsgerror(_ERRMSGNODELETE);
    } else {
        $xrefresh = ($nextid) ? ($refresh * 2) : $refresh;
        pmxHeader::add('<meta http-equiv="Refresh" content="' . $xrefresh . ';URL=modules.php?name=' . $module_name . '">');

        echo "<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">"
         . "<tr class=\"bgcolor2\" align=\"center\"><td><br />" . _PMSMSGDELETED . '<br /><br />';
        if ($nextid) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=index\">" . mxCreateImage("$url_images/privatemessages.png", _PMSRETURNTOPMSG) . "</a> &nbsp; <a href=\"modules.php?name=$module_name&amp;op=read&amp;id=$nextid\">" . mxCreateImage("$url_images/right.gif", _PMSNEXT) . "</a>";
        } else {
            echo "<a href=\"modules.php?name=$module_name\">" . _PMSRETURNTOPMSG . "</a>";
        }
        echo "<br /><br /></td></tr></table>";
    }
}

function deletemessages($arrformvars, $uid)
{
    global $prefix, $refresh, $module_name;
    $status = 0;
    $delmess = array();
    if (isset($arrformvars["msg_id"])) {
        foreach ($arrformvars["msg_id"] as $key => $val) {
            $delmess[] = (int)$val;
            $status++;
        }
        if (count($delmess)) {
            $delmess = implode(',', $delmess);
            $del_unread = (empty($GLOBALS['allow_delete_unread'])) ? 'AND (read_msg <> 0)' : '';
            $qry = "DELETE FROM {$prefix}_priv_msgs WHERE (msg_id IN (" . $delmess . ")) AND (to_userid=" . $uid . ") " . $del_unread . " OR (from_userid = 0) OR (msg_text IS NULL) OR (subject IS NULL) OR (msg_text='') OR (subject='')";
            sql_query($qry);
            $qry = "SELECT COUNT(msg_id) FROM {$prefix}_priv_msgs WHERE (to_userid = " . $uid . ") AND msg_id IN (" . $delmess . ")";
            $result = sql_query($qry);
            list($delmess) = sql_fetch_row($result);
            $status = $status - ((int)$delmess);
        }
    }
    pmxHeader::add('<meta http-equiv="Refresh" content="' . $refresh . ';URL=modules.php?name=' . $module_name . '">');

    echo "<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">"
     . "<tr class=\"bgcolor2\" align=\"center\"><td><br />";
    if ($status) {
        echo _PMSMSGDELETED2 . " (" . $status . "x)";
    } else {
        echo _PMSMSGNOTODELETE;
    }
    echo "<br /><br /><a href=\"modules.php?name=$module_name\">" . _PMSRETURNTOPMSG . "</a><br /><br /></td></tr></table>";
}

function pm_pager($page, $allrows, $op = '')
{
    global $module_name, $pagesize;

    /* 5 sollten es schon sein... */
    $pagesize = (empty($pagesize) || intval($pagesize) < 5) ? 5 : intval($pagesize);

    if ($allrows <= $pagesize) {
        return '&nbsp;';
    }

    /* Anzahl aller Seiten */
    $numpages = ceil($allrows / $pagesize);

    $start = 1;
    $end = $numpages + 1;
    if ($numpages > 10) {
        $start = $page - 4;
        if ($start < 1) $start = 1;
        $end = $start + 10;
        if ($end > $numpages) $end = $numpages + 1;
        if ($end == $numpages + 1) $start = $end - 10;
    }

    $link = 'modules.php?name=' . $module_name . (($op == 'sendmsg') ? '&amp;op=sendmsg' : '');

    $out = '<div class="pagination align-center">';

    if ($page <= 1) {
        $out .= '<a class="disabled">&nbsp;&laquo;&nbsp;</a>';
    } else {
        $caption = _GOTOPAGEPREVIOUS . ': ' . ($page - 1) ;
        $backlink = ($page > 1) ? ' href="' . $link . '&amp;page=' . ($page - 1) . '"' : '';
        $out .= '<a' . $backlink . ' title="' . $caption . '">&nbsp;&laquo;&nbsp;</a>';
    }

    if ($start > 1) {
        $out .= '<a href="' . $link . '&amp;page=1" title="' . _GOTOPAGEFIRST . '">1</a>';
        if ($start > 2) $out .= ' .. ';
    }
    for ($i = $start; $i < $end; $i++) {
        if ($i == $page) {
            $out .= '<a class="current">' . $i . '</a>';
        } else {
            $out .= '<a href="' . $link . '&amp;page=' . $i . '" title="' . _GOTOPAGE . ': ' . $i . '">' . $i . '</a>';
        }
    }
    if ($end < $numpages + 1) {
        if ($end < $numpages) $out .= ' .. ';
        $out .= '<a href="' . $link . '&amp;page=' . $numpages . '" title="' . _GOTOPAGELAST . '">' . $numpages . '</a>';
    }

    if ($page >= $numpages) {
        $out .= '<a class="disabled">&nbsp;&raquo;&nbsp;</a>';
    } else {
        $caption = _GOTOPAGENEXT . ': ' . ($page + 1) ;
        $nextlink = ($page < $numpages) ? ' href="' . $link . '&amp;page=' . ($page + 1) . '"' : '';
        $out .= '<a' . $nextlink . ' title="' . $caption . '">&nbsp;&raquo;&nbsp;</a>';
    }

    $out .= '</div>';
    $out = str_replace('</a>', "</a>\n", $out);

    return $out;
}

function sendmsg($uid)
{
    global $prefix, $user_prefix, $module_name, $url_smiles, $url_icons, $subjectdefaulticon, $url_images, $pagesize;
    global $popupwidth, $poptableborder;

    /* Gesamtzahl der PM'S berechnen, fuer Pager */
    $result = sql_query("SELECT COUNT(to_userid) FROM `{$prefix}_priv_msgs_send` where from_userid = " . intval($uid));
    list($allrows) = sql_fetch_row($result);

    /* Limit fuer Pager berechnen */
    $pagesize = (empty($pagesize) || intval($pagesize) < 5) ? 5 : intval($pagesize);
    $page = (empty($_REQUEST['page']) || intval($_REQUEST['page']) < 1) ? 1 : intval($_REQUEST['page']);
    $maxpages = ceil($allrows / $pagesize);
    if ($page > $maxpages) {
        $page = $maxpages;
    }
    $min = $pagesize * ($page - 1);
    if ($min < 1) {
        $min = 0;
    }

    /* Datensaetze auslesen */
    $result = sql_query("SELECT {$prefix}_priv_msgs_send.*, UNIX_TIMESTAMP(msg_time) as msgtimestamp, {$user_prefix}_users.uname as toname
                        FROM {$prefix}_priv_msgs_send
                        LEFT JOIN {$user_prefix}_users
                        ON {$prefix}_priv_msgs_send.to_userid = {$user_prefix}_users.uid
                        WHERE from_userid = " . intval($uid) . "
                        ORDER BY msg_time DESC
                        LIMIT " . $min . ", " . $pagesize);
    if (!$result) {
        return prvmsgerror(_ERRMSGDATABASE);
    }
    if (!$total_messages = sql_num_rows($result)) {
        $havemessages = 0;
    } else {
        $havemessages = 1;
        pmxHeader::add_script(PMX_MODULES_PATH . $module_name . '/javascript.js');
        pmxHeader::add_jquery('ui/jquery-ui-pmx-core.min.js', 'ui/jquery.ui.tooltip.min.js');

        ?>
<script type="text/javascript">
/* <![CDATA[ */
$(document).ready(function() {
    $('.tooltip-info').tooltip();
});
/* ]]> */
</script>

<?php
    }
    $count = 0;
    echo "<form name=\"prvmsg\" method=\"post\" action=\"modules.php?name=" . $module_name . "\">\n";
    echo "<input type=\"hidden\" name=\"name\" value=\"" . $module_name . "\" />\n";

    echo "<div><br />&nbsp;&nbsp;" . mxCreateImage("$url_images/outbox.png", _ESENTPMS) . "<b>&nbsp;&nbsp;" . _PMOUT . "</b><br /><br /></div> ";
    echo "<table cellspacing=\"1\" cellpadding=\"1\" width=\"100%\" class=\"bgcolor2\">\n";
    if (!$havemessages) {
        echo "<tr class=\"bgcolor3\">\n<td colspan=\"6\" align=\"center\"><br /><br /><br /><b>" . _SENTPMSDONTHAVESOME . "</b><br /><br /><br /></td>\n</tr>\n";
    } else {
        echo "<tr class=\"bgcolor2\">\n"
         . "<td colspan=\"5\" class=\"bgcolor2\" align=\"left\"><font class=\"content\"><b>&nbsp;&nbsp;" . _SENTPMS . "</b></font><br /></td></tr>\n";
        echo "<tr class=\"bgcolor2\">\n"
         . "<td></td>\n"
         . "<td align=\"center\" class=\"bgcolor2\">" . mxCreateImage($url_images . '/down.gif', _PMSMSGSTATUS) . "</td>"
         . "<td align=\"center\" class=\"bgcolor2\">&nbsp;</td>\n"
         . "<td><font class=\"content\"><b>" . _SENTPMSTO . "</b></font></td>\n"
         . "<td align=\"center\"><font class=\"content\"><b>" . _PMSSUBJECT . "</b></font></td>\n"
         . "<td align=\"center\"><font class=\"content\"><b>" . _PMSDATE . "</b></font></td>\n"
         . "</tr>\n";
        while ($row = sql_fetch_array($result)) {
            // Nachrichten ungelesenen auslesen fr "pix" ----->
            $pm_uhrzeit = $row["msg_time"];
            $select1 = "SELECT * FROM {$prefix}_priv_msgs ";
            $where1 = "where msg_time = '$pm_uhrzeit'";
            $result_read_msg = sql_query($select1 . $where1);
            // <----- bis hier
            if (empty($row["msg_image"])) $row["msg_image"] = $subjectdefaulticon;
            if (empty($row["toname"])) $row["toname"] = "";
            $postedtime = mx_strftime(_PMSTIMESTRING, $row["msgtimestamp"]);
            $row["subject"] = strip_tags($row["subject"]);
            $row["subject"] = msg_smile($row["subject"]);

            $row["msg_text"] = strip_tags($row["msg_text"], "<img><br><hr><b><i>");
            // $row["msg_text"] = str_replace(array('&#41;','&#124;'),array(')','|'),$row["msg_text"]); /// macht mxSecureValue() rckgngig
            $row["msg_text"] = pmPrepDisplay($row["msg_text"]);

            $tooltip = pmValueToText($row["msg_text"]);

            echo "<tr><td class=\"bgcolor1\" width=\"2%\" align=\"center\"><input type=\"checkbox\" onclick=\"CheckCheckAll();\" name=\"msg_id[$count]\" value=\"" . (int)$row["msg_id"] . "\" style=\"background-color: transparent;\" />";
            echo "</td>\n";
            echo "<td width=\"5%\" align=\"center\" class=\"bgcolor1\">";
            // ab hier Abfrage fr schon gelesen "pix"---->
            // Eigene Nachrichten auslesen
            $ungelesen = mysql_fetch_array($result_read_msg);

            if ($ungelesen["read_msg"] == 0 && $ungelesen["read_msg"] != "") {
                echo "<img src=\"$url_images/unread.gif\" border=\"0\" alt=\"" . _PMSNOTREAD . "\">";
            } elseif (is_null($ungelesen["read_msg"])) {
                echo "<img src=\"$url_images/cancel.png\" border=\"0\" alt=\"" . _PMSDELETED . "\">";
            } else {
                echo "<img src=\"$url_images/read.gif\" border=\"0\" alt=\"" . _PMSREAD . "\">";
            }
            /*            if ($ungelesen["read_msg"] == "0") {
                echo "<img src=\"$url_images/read.gif\" border=\"0\" alt=\"" . _PMSNOTREAD . "\">";
            } else {
                echo "";
            }*/
            // <----- bis hier
            echo "</td>\n";
            echo '<td class="bgcolor3 align-center" width="5%"><a href="modules.php?name=' . $module_name . '&amp;op=read_sent&amp;id=' . $row['msg_id'] . '">' . mxCreateImage($url_icons . '/' . $row['msg_image']) . '</a></td>';
            echo "<td class=\"bgcolor1\" width=\"10%\"><font class=\"content\">" . mxCreateUserprofileLink($row["toname"]) . "</font></td>\n";
            echo "<td class=\"bgcolor3\"><a href=\"modules.php?name=$module_name&amp;op=read_sent&amp;id=" . $row["msg_id"] . "\" class=\"tooltip-info\" title=\"" . $tooltip . "\"><font class=\"tiny\">" . $row["subject"] . "</font></a></td>\n";
            echo "<td class=\"bgcolor1\" align=\"center\" width=\"18%\"><font class=\"tiny\">$postedtime</font></td>\n";
            echo "</tr>\n";
            $count++;
        }

        if ($havemessages) {
            echo "<tr class=\"bgcolor2\">\n"

             . "<td class=\"bgcolor2\" align=\"center\"><input name=\"allbox\" onclick=\"CheckAll();\" type=\"checkbox\" value=\"" . _PMSCHECKALL . "\" style=\"background-color: transparent;\" /></td>\n"
             . "<td><font class=\"content\">" . _PMALL . "</font></td>\n"
             . "<td></td>\n"
             . "<td></td>\n"
             . "<td></td>\n"
             . "<td align=\"right\"><font class=\"content\">" . _SAVEPMSS . "&nbsp;<a href=\"modules.php?name=$module_name&amp;op=speichern\">" . mxCreateImage("$url_images/disk.png", _SAVEPMS) . "</a>&nbsp;&nbsp;</font></td>\n"
             . "</tr>\n";
        }
    }

    echo "<tr class=\"bgcolor2\">\n<td colspan=\"6\">";
    if ($havemessages) {
        echo "&nbsp;" . mxCreateImage("$url_images/arrow_top.gif") . _PMDEL . "&nbsp;<input type=\"image\" src=\"$url_images/email_delete.png\" name=\"delete_messages\" value=\"delete_messages\" style=\"background-color: transparent; border: none;\" alt=\"" . _PMSDELETE . "\" title=\"" . _PMSDELETE . "\">";
        echo "<input type=\"hidden\" name=\"total_messages\" value=\"" . (int)$total_messages . "\" />";
        echo "<input type=\"hidden\" name=\"op\" value=\"delete_sent_messages\"> ";
        echo "<br /><br />&nbsp;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=send\">" . mxCreateImage("$url_images/mail_new.png", _PMSPRIVATEMESSAGESEND) . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;op=send\">" . _PMSPRIVATEMESSAGESEND . "</a> ";
        echo "&nbsp;&nbsp;<a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/inbox.png", _ESENTPMS) . "</a>&nbsp;<a href=\"modules.php?name=$module_name\">" . _ESENTPMS . "</a>";
        echo pm_pager($page, $allrows, 'sendmsg');
    } else {
        echo "<br /><br />&nbsp;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=send\">" . mxCreateImage("$url_images/mail_new.png", _PMSPRIVATEMESSAGESEND) . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;op=send\">" . _PMSPRIVATEMESSAGESEND . "</a> ";
        echo "&nbsp;&nbsp;<a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/inbox.png", _ESENTPMS) . "</a>&nbsp;<a href=\"modules.php?name=$module_name\">" . _ESENTPMS . "</a><br /><br />";
    }
    echo "</td>\n</tr>\n</table>\n</form>";
}

function readsentmessage($id, $uid)
{
    global $prefix, $user_prefix, $module_name, $url_smiles, $url_icons, $url_images, $blankavatar;
    global $allow_bbcode, $allow_html ;
    list($id, $uid) = mxForceInteger($id, $uid);
    $qry = "SELECT {$prefix}_priv_msgs_send.*, UNIX_TIMESTAMP(msg_time) as msgtimestamp FROM {$prefix}_priv_msgs_send WHERE (from_userid=$uid) and (msg_id=$id);";
    $result = sql_query($qry);
    if (!$result) {
        return prvmsgerror(_ERRMSGDATABASE);
    }
    $row = sql_fetch_array($result);
    if (!$row["msg_id"]) {
        msgindex($uid);
    } else {
        $posterdata = get_userdata_from_id($row["to_userid"]);
        $postedtime = mx_strftime(_PMSTIMESTRING, $row["msgtimestamp"]);

        $replymsg = pmUndoPrepDisplay($row['msg_text']);
        $replymsg = "[quote][i]" . _ON . " " . $postedtime . ", " . _PMSWROTE . " " . $posterdata['uname'] . ":[/i]\n" . $replymsg . "\n[/quote]\n";

        $row["msg_text"] = pmPrepDisplay($row["msg_text"]);

        $qry = "SELECT msg_id FROM {$prefix}_priv_msgs_send WHERE from_userid=$uid and msg_time>'" . $row["msg_time"] . "' and msg_id<>'" . $row["msg_id"] . "' and (from_userid is not null) order by msg_time asc LIMIT 0,1";
        list($next) = sql_fetch_row(sql_query($qry));
        $qry = "SELECT msg_id FROM {$prefix}_priv_msgs_send WHERE from_userid=$uid and msg_time<'" . $row["msg_time"] . "' and msg_id<>'" . $row["msg_id"] . "' and (from_userid is not null) order by msg_time desc LIMIT 0,1";
        list($previous) = sql_fetch_row(sql_query($qry));
        // $qry = "UPDATE {$prefix}_priv_msgs_send SET read_msg=1 WHERE msg_id=" . $row["msg_id"];
        $result = sql_query($qry);
        if (!$result) {
            return prvmsgerror(_ERRMSGDATABASE);
        }

        if (empty($posterdata["user_sig"])) {
            $rowspan = "2";
        } else {
            $rowspan = "3";
            $posterdata["user_sig"] = pmPrepDisplay(pmxSigBbCode($posterdata["user_sig"]));
        }

        echo "<div><br />&nbsp;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=sendmsg\">" . mxCreateImage("$url_images/outbox.png", _PMOUT) . "</a><b>&nbsp;&nbsp;<a href=\"modules.php?name=$module_name&amp;op=sendmsg\">" . _PMOUT . "</a></b><br /><br /></div> ";
        echo"<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">";
        echo "<tr class=\"bgcolor1\"><td colspan=\"2\"><font class=\"content\">"
         . "<a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/privatemessages.png", _PMSRETURNTOPMSG) . "</a> &nbsp;";
        if ($previous) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=read_sent&amp;id=$previous\">" . mxCreateImage("$url_images/left.gif", _PMSPREVIOUS) . "</a> &nbsp;";
        } else {
            echo mxCreateImage("$url_images/left.gif", _PMSPREVIOUS) . " &nbsp;";
        }
        if ($next) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=read_sent&amp;id=$next\">" . mxCreateImage("$url_images/right.gif", _PMSNEXT) . "</a>";
        } else {
            echo mxCreateImage("$url_images/right.gif", _PMSNEXT);
        }
        echo "</font></td></tr>"
         . "<tr class=\"bgcolor2\">"
         . "<td colspan=\"2\"><font class=\"title\">" . _PMSPRIVATEMESSAGE . ": &nbsp;&nbsp;<b><i>" . msg_smile($row["subject"]) . "</i></b></font></td>"
         . "</tr>"
         . "<tr class=\"bgcolor3\">\n"
         . "<td valign=\"top\" rowspan=\"" . $rowspan . "\" width=\"20%\">" . _SENTPMSTO . ": <b>" . $posterdata["uname"] . "</b><br /><br />\n";


        /* aktuelles Benutzerbild ermitteln */
        $pici = load_class('Userpic', $posterdata);
        $ug_img = $pici->getHtml('small');
        if ($ug_img) {
            echo $ug_img . '<br />';
        }



        echo "<br /><a href=\"modules.php?name=Userinfo&amp;uname=" . urlencode($posterdata["uname"]) . "\"><img src=\"$url_images/profile.gif\" border=\"0\" alt=\"" . _PMSPROFILE . "\"><font class=\"tiny\">" . _PMSPROFILE . "</font></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />\n"
         . get_onlinestatus($posterdata["uname"])
         . "</td>"
         . "<td width='80%' height='10' valign='top'><img src=\"" . $url_icons . "/" . $row["msg_image"] . "\" alt=\"\">&nbsp;<font class=\"content\">" . _PMSSENT . ": $postedtime</font></td></tr>"
         . "<tr class=\"bgcolor1\"><td width='80%' height='80' valign='top'>" . $row["msg_text"] . "<br /><br /></td></tr>";

        if (!empty($posterdata["user_sig"])) {
            echo "<tr class=\"bgcolor3\"><td width='80%' height='10'><div class=\"tiny\">" . $posterdata["user_sig"] . "</div></td></tr>\n";
        }

        echo "<tr class=\"bgcolor2\"><td colspan=\"2\">"
         . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>"
         . "<td><a href=\"modules.php?name=$module_name&amp;op=delete_sent&amp;msg_id=" . $row["msg_id"] . "\">" . mxCreateImage("$url_images/email_delete.png", _PMSDELETE) . "</a>&nbsp;<a href=\"modules.php?name=$module_name&amp;op=delete_sent&amp;msg_id=" . $row["msg_id"] . "\">" . _PMSDELETE . "</a>\n</td>\n"
        // . "<td><a href=\"modules.php?name=$module_name&amp;op=delete_sent&amp;msg_id=" . $row["msg_id"] . "\">" . mxCreateImage("$url_images/email_delete.png", _PMSDELETE) . "</a>\n"
        . "<td align=\"right\">"
         . "<a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/privatemessages.png", _PMSRETURNTOPMSG) . "</a> &nbsp;";
        if ($previous) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=read_sent&amp;id=$previous\">" . mxCreateImage("$url_images/left.gif", _PMSPREVIOUS) . "</a> &nbsp;";
        } else {
            echo mxCreateImage("$url_images/left.gif", _PMSPREVIOUS) . " &nbsp;";
        }
        if ($next) {
            echo "<a href=\"modules.php?name=$module_name&amp;op=read_sent&amp;id=$next\">" . mxCreateImage("$url_images/right.gif", _PMSNEXT) . "</a>";
        } else {
            echo mxCreateImage("$url_images/right.gif", _PMSNEXT);
        }
        echo "</td></tr></table>"
         . "</td></tr></table>";
    }
}

function deletesentmessage($msg_id, $uid)
{
    global $prefix, $user_prefix, $module_name, $refresh, $url_images;
    list($msg_id, $uid) = mxForceInteger($msg_id, $uid);
    $qry = "SELECT msg_time FROM {$prefix}_priv_msgs_send WHERE (from_userid=$uid) and (msg_id=$msg_id) and (from_userid is not null) LIMIT 0,1";
    list($time) = sql_fetch_row(sql_query($qry));
    $qry = "SELECT msg_id FROM {$prefix}_priv_msgs_send WHERE (from_userid=$uid) and (msg_time>'$time') and (msg_id<>$msg_id) and (from_userid is not null) order by msg_time asc LIMIT 0,1";
    list($nextid) = sql_fetch_row(sql_query($qry));
    $qry = "DELETE FROM {$prefix}_priv_msgs_send WHERE (msg_id=$msg_id) AND (from_userid=$uid) or (from_userid is null)";
    if (!sql_query($qry)) {
        return prvmsgerror(_ERRMSGNODELETE);
    } else {
        echo "<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">"
         . "<tr class=\"bgcolor2\" align=\"center\"><td><br />" . _PMSMSGDELETED . "<br /><br />";
        if ($nextid) {
            $xrefresh = $refresh * 2;
            pmxHeader::add('<meta http-equiv="Refresh" content="' . $xrefresh . ';URL=modules.php?name=' . $module_name . '&amp;op=read&amp;id=' . $nextid . '">');
            echo "<a href=\"modules.php?name=$module_name&amp;op=index\"><img src=\"$url_images/privatemessages.png\" border=\"0\" alt=\"" . _PMSRETURNTOPMSG . "\"></a> &nbsp; <a href=\"modules.php?name=$module_name&amp;op=read&amp;id=$nextid\"><img src=\"$url_images/right.gif\" border=\"0\" alt=\"" . _PMSNEXT . "\"></a>";
        } else {
            pmxHeader::add('<meta http-equiv="Refresh" content="' . $refresh . ';URL=modules.php?name=' . $module_name . '&amp;op=sendmsg">');
            echo "<a href=\"modules.php?name=$module_name&amp;op=sendmsg\">" . _PMSRETURNTOPMSG . "</a>";
        }
        echo "<br /><br /></td></tr></table>";
    }
}

function deletesentmessages($arrformvars, $uid)
{
    global $prefix, $refresh, $module_name;
    $status = 0;
    if (isset($arrformvars["msg_id"])) {
        list($uid, $arrformvars["msg_id"]) = mxForceInteger($uid, $arrformvars["msg_id"]);
        while (list($key, $val) = each($arrformvars["msg_id"])) {
            $qry = "DELETE FROM {$prefix}_priv_msgs_send WHERE (msg_id=$val) AND (from_userid=$uid) or (from_userid is null)";
            if (!sql_query($qry)) {
                return prvmsgerror(_ERRMSGNODELETE);
            } else {
                $status = 1;
            }
        }
    }

    pmxHeader::add('<meta http-equiv="Refresh" content="' . $refresh . ';URL=modules.php?name=' . $module_name . '&amp;op=sendmsg">');

    echo "<table cellspacing=\"1\" cellpadding=\"3\" width=\"100%\" class=\"bgcolor2\">"
     . "<tr class=\"bgcolor2\" align=\"center\"><td><br />";
    if ($status) {
        echo _PMSMSGDELETED2;
    } else {
        echo _PMSMSGNOTODELETE;
    }
    echo "<br /><br /><a href=\"modules.php?name=$module_name&amp;op=sendmsg\">" . _PMSRETURNTOPMSG . "</a><br /><br /></td></tr></table>";
}
// PM per E-Mail sichern
function msgsichern($uid)
{
    global $prefix, $user_prefix, $module_name, $url_smiles, $subjectdefaulticon, $url_images;
    global $popupwidth, $poptableborder;
    $kopf = "" . _HELLO . ",\n" . _PMEMAIL . PMX_HOME_URL . _YOURMAILPMS . _HPMS . ":\n";
    $linie1 = "--------------------------------------------------------------------------------------------------------------------";
    $linie2 = "************************************************************************************************";
    $nachricht = $kopf;
    $qry = "SELECT subject, from_userid, msg_time, msg_text FROM {$prefix}_priv_msgs WHERE to_userid=" . $uid . " order by msg_time desc";
    $result = sql_query($qry);
    while (list($subject, $from_userid, $msg_time, $msg_text) = sql_fetch_row($result)) {
        $qry2 = "SELECT * FROM {$user_prefix}_users WHERE uid=" . $from_userid;
        $result2 = sql_query($qry2);
        $row = sql_fetch_array($result2);
        $absender = $row["uname"];
        $nachricht .= "$linie2\n";
        $nachricht .= " " . _TOPMS . " $msg_time " . _SPMS . " $absender:\n";
        $nachricht .= "$linie1\n";
        $nachricht .= " $msg_text\n";
    }
    $nachricht .= "$linie2\n";
    $nachricht .= "\n\n" . _AOPMS . ":\n\n";

    $qry4 = "SELECT subject, to_userid, msg_time, msg_text FROM {$prefix}_priv_msgs_send WHERE from_userid=" . $uid . "  order by msg_time desc";
    $result4 = sql_query($qry4);
    while (list($subject, $to_userid, $msg_time, $msg_text) = sql_fetch_row($result4)) {
        $qry5 = "SELECT * FROM {$user_prefix}_users WHERE uid=" . $to_userid;
        $result5 = sql_query($qry5);
        $row5 = sql_fetch_array($result5);
        $empfang = $row5["uname"];
        $nachricht .= "$linie2\n";
        $nachricht .= " " . _TOPMS . " $msg_time " . _ANPMS . " $empfang:\n";
        $nachricht .= "$linie1\n";
        $nachricht .= " $msg_text\n";
    }

    $nachricht .= "$linie2\n";
    $nachricht .= "\n" . _MFGPMS . "\n " . _PMSBOX;
    $qry3 = "SELECT * FROM {$user_prefix}_users WHERE uid=" . $uid;
    $result3 = sql_query($qry3);
    $row2 = sql_fetch_array($result3);
    $email = $row2["email"];
    $absend = $row2["uname"];
    mxmail($email, _PMSSI, $nachricht, $email, "", "", $absend);
    messagesheader();
    OpenTable();
    echo '<center><b>' . _YOURPMS . '</b></center>';
    echo "<div style=\"float:right;\"><a href=\"modules.php?name=$module_name\">" . mxCreateImage("$url_images/privatemessages.png", _PMSRETURNTOPMSG) . "</a></div> ";
    CloseTable();
}
// PM per E-Mail sichern ende


function messagesheader($modus = 'read')
{
    global $url_images, $module_name, $prefix, $user_prefix;

    $windowname = md5($GLOBALS['sitename']);
    $modus = ($modus == 'send') ? '' : '&amp;op=sendmsg';

    /* PM Begrenzung */
    $status = mxPmBoxstatus();
    // mxDebugFuncVars($status);
    $getbox = $status['get'];
    $sendbox = $status['send'];

    if ($getbox['limit'] || $sendbox['limit']) {
        pmxHeader::add_style('modules/' . $GLOBALS['module_name'] . '/style/bar.css');
        if ($getbox['box'] >= $getbox['limit']) {
            $getbox['free'] = '<span style="color: red;">' . $getbox['free'] . '</span>';
        }
        if ($sendbox['box'] >= $sendbox['limit']) {
            $sendbox['free'] = '<span style="color: red;">' . $sendbox['free'] . '</span>';
        }
        // Balkenanzeige
        $prozentpninbox = ($getbox['limit']) ? floor($getbox['box'] * 100 / $getbox['limit']) : 0;
        // mit floor() gleich abrunden
        $prozentpnoutbox = ($sendbox['limit']) ? floor($sendbox['box'] * 100 / $sendbox['limit']) : 0;

        switch (true) {
            case $prozentpninbox < 75:
                $makefullA = "background-color: green;";
                break;
            case $prozentpninbox < 90:
                $makefullA = "background-color: orange;";
                break;
            case $prozentpninbox > 100:
                $prozentpninbox = 100; // falls uebervoll, auf 100% stellen
            default:
                $makefullA = "background-color: red;";
        }

        switch (true) {
            case $prozentpnoutbox < 75:
                $makefullB = "background-color: green;";
                break;
            case $prozentpnoutbox < 90:
                $makefullB = "background-color: orange;";
                break;
            case $prozentpnoutbox > 100:
                $prozentpnoutbox = 100; // falls uebervoll, auf 100% stellen
            default:
                $makefullB = "background-color: red;";
        }

        $in = '<div class="gfx"><div class="bar-normal"><div class="bar" style="' . $makefullA . ' width:' . $prozentpninbox . '%;"></div></div></div>
				<div class="value td-r">' . $prozentpninbox . '%</div>';
        $out = '<div class="gfx"><div class="bar-normal"><div class="bar " style="' . $makefullB . ' width:' . $prozentpnoutbox . '%;"></div></div></div>
				<div class="value td-r ">' . $prozentpnoutbox . '%</div>';

        if ($getbox['error']) {
            $in .= '<div class="warning">' . _GETPMBOXVOLL . '</div>';
        }

        if ($sendbox['error']) {
            $out .= '<div class="warning">' . _SENTPMBOXVOLL . '</div>';
        }
        // Ende Balkenanzeige
    }
    /* Ende PM Begrenzung */

    include_once("modules/Your_Account/navbar.php");
    OpenTable();
    nav();
    CloseTable();
    echo '<br />';
    OpenTable();
    echo "
    <div class=\"title\">" . _PMSPRIVATEMESSAGES . "</div>
    <div style=\"float:right; margin-bottom: .5em;\"><button onclick=\"window.open('modules.php?name=" . $module_name . "&amp;file=buddy','$windowname','left=180, top=150, width=240,height=350,toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=yes,copyhistory=no'); return false;\" title=\"" . _PMSDISCRIBE . "\">" . _PMSTITLE . "</button></div>
    ";

    /* PM Begrenzung */
    if ($getbox['limit'] || $sendbox['limit']) {
        echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"3\">\n";
        echo "<tr class=\"bgcolor2\">\n";
        echo "<th width=\"50%\" class=\"content\">" . _PMNE . "</th>\n";
        echo "<th width=\"50%\" class=\"content\">" . _PMNA . "</th>\n";
        echo "</tr>\n";

        echo "<tr class=\"bgcolor3\">\n";
        echo "<td align=\"center\" class=\"content\">" . _PMNOCH . $getbox['free'] . _PMFREI . _PMVON . $getbox['limit'] . "</td>\n";
        echo "<td align=\"center\" class=\"content\">" . _PMNOCH . $sendbox['free'] . _PMFREI . _PMVON . $sendbox['limit'] . "</td>\n";
        echo "</tr>\n";
        // Balkenanzeige
        echo "<tr class=\"bgcolor3\" class=\"beispiel-1\" valign=\"top\">\n";
        echo "<td>" . $in . "</td>\n";
        echo "<td>" . $out . "</td>\n";
        echo "</tr>\n";
        // Ende Balkenanzeige
        echo "</table>\n";
    }
    /* Ende PM Begrenzung */
    CloseTable();
    // echo '<br />';
}


/**
 * mainprog
 */
if (!MX_IS_USER) {
    mxRedirect(PMX_HOME_URL . "/modules.php?name=Your_Account&op=login");
    exit;
} else {
    $module_name = basename(dirname(__FILE__));
    define('MX_ML_IMAGEPATH', 'modules/' . $module_name . '/images/');
    // Link verwendet in Sprachdateien
    if (!defined('_PMSBBCODELINK')) define('_PMSBBCODELINK', "<a href=\"#\" onclick=\"window.open('modules.php?name=" . $module_name . "&amp;file=bbcode','pmbbcode','width=640, height=480, left=10, top=10, scrollbars=yes, resizable=yes, toolbar=no, location=no, status=no, menubar=no'); return false;\" style=\"cursor: help;\">");

    $userdata = mxGetUserData();

    $_REQUEST["op"] = (empty($_REQUEST["op"])) ? "index" : $_REQUEST["op"];
    $_REQUEST["uname"] = (empty($_REQUEST["uname"])) ? $userdata["uid"] : $_REQUEST["uname"];
    $_REQUEST["to_user"] = (empty($_REQUEST["to_user"])) ? $userdata["uname"] : $_REQUEST["to_user"];

    include_once(PMX_MODULES_DIR . DS . $module_name . "/config.php");
    include_once(PMX_MODULES_DIR . DS . $module_name . "/bbfunctions.php");
    include_once(PMX_MODULES_DIR . DS . $module_name . "/functions.php");
    mxGetLangfile($module_name);

    if ($_REQUEST["op"] == "userslist") {
        userslist();
        exit;
    }

    $pagetitle = _PMSPRIVATEMESSAGES;

    ob_start();

    echo "\n<!-- beginn $module_name output -->\n";

    if (isset($_REQUEST['mode']) && isset($_REQUEST['u'])) {
        $_REQUEST['op'] = $_REQUEST['mode'];
        $xinfo = mxGetUserDataFromUid($_REQUEST['u']);
        $_REQUEST["to_user"] = $xinfo['uname'];
    }

    switch ($_REQUEST['op']) {
        case "read":
            readmessage($_REQUEST["id"], $userdata["uid"]);
            break;
        case "reply":
            sendmessage($_REQUEST["id"], $userdata["uid"]);
            break;
        case "send":
            sendmessage(0, (isset($_REQUEST["uname"]) ? $_REQUEST["uname"] : ''));
            break;
        case "post":
        case "send_to":
            sendmessage(0, (isset($_REQUEST["uname"]) ? $_REQUEST["uname"] : ''), (isset($_REQUEST["to_user"]) ? $_REQUEST["to_user"] : ''));
            break;
        case "submit":
            if (isset($_REQUEST["submit"])) {
                submitmessage($_REQUEST, $userdata["uid"]);
            } else {
                cancelsubmit($_REQUEST["msg_id"], $userdata["uid"]);
            }
            break;
        case "delete":
            deletemessage($_REQUEST["msg_id"], $userdata["uid"]);
            break;
        case "delete_messages":
            deletemessages($_REQUEST, $userdata["uid"]);
            break;
        case "read_sent":
            readsentmessage($_REQUEST["id"], $userdata["uid"]);
            break;
        case "delete_sent":
            deletesentmessage($_REQUEST["msg_id"], $userdata["uid"]);
            break;
        case "delete_sent_messages":
            deletesentmessages($_REQUEST, $userdata["uid"]);
            break;
        case "sendmsg":
            sendmsg($userdata["uid"]);
            break;
        case "speichern":
            msgsichern($userdata["uid"]);
            break;
        default:
            msgindex($userdata["uid"]);
            break;
    }
    echo "\n<!-- end $module_name output -->\n";

    $out = ob_get_clean();

    if ($out) {
        require_once(PMX_SYSTEM_DIR . DS . 'mx_userfunctions.php');
        pmxHeader::add_style(PMX_MODULES_PATH . $module_name . '/style/style.css');

        $windowname = md5($GLOBALS['sitename']);
        $out = "
    <div class=\"buddybutton\"><button onclick=\"window.open('modules.php?name=" . $module_name . "&amp;file=buddy','$windowname','left=180, top=150, width=240,height=350,toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=yes,copyhistory=no'); return false;\" title=\"" . _PMSDISCRIBE . "\">" . _PMSTITLE . "</button></div>
    " . $out;

        $view = new pmxUserPage($userdata);
        $view->tabname = 'pmxprivmess';
        $view->subtitle = _PMSPRIVATEMESSAGES;
        $view->show($out);
    }
}

?>