<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.5.4.2 $
 * $Author: tora60 $
 * $Date: 2010/09/15 21:46:48 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Part of phpBB integration
 * Copyright (c) 2001 by
 * Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
 * Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
 * http://www.phpnuke.web.id
 *
 * translation by: Wilhelm Moellering, http://www.humanmedia.dk
 */

defined('mxMainFileLoaded') or die('access denied');

global $sitename;

define("_PMSRE", "re");
define("_PMSSUBJECT", "emne");
define("_PMSPRIVATEMESSAGES", "dine private meddelelser");
define("_PMSCHECKALL", "maker alt");
define("_PMSFROM", "fra");
define("_PMSDATE", "dato");
define("_PMSDONTHAVESOME", "Du har for tiden ingen meddelelser.");
define("_PMSNOTREAD", "ulst");
define("_PMSMSGSTATUS", "meddelelser status");
define("_PMSPRIVATEMESSAGESEND", "send privat meddelelse");
define("_PMSPRIVATEMESSAGE", "privat meddelelse");
define("_PMSSENT", "sendt");
define("_PMSPREVIOUS", "sidste meddelelse");
define("_PMSNEXT", "nste meddelelse");
define("_PMSPROFILE", "profil");
define("_PMSTO", "til");
define("_PMSTOALL1", "til alle");
define("_PMSTOALL2", "Send denne meddelelse til alle registrerede brugere? Advarsel!");
define("_PMSMESSAGEICON", "piktogramm af meddelelsen");
define("_PMSMESSAGE", "meddelelse");
define("_PMSHTML", "HTML");
define("_PMSPMON", "slet til");
define("_PMSOFF", "slet fra");
define("_PMSBBCODE", "BBCode");
define("_PMSWROTE", "skrev");
define("_PMSCANCELSEND", "Annuller afsendelse");
define("_PMSCLEAR", "reset");
define("_PMSSUBMIT", "Submit");

define("_PMSUSERNOTINDB", "Den valgte bruger eksisterer ikke.<br />Kontroller navnet og prv igen.");
define("_PMSMSGPOSTED", "Din meddelelse blev sendt.");
define("_PMSRETURNTOPMSG", "Klik her, for at aktualisere din private meddelelse.");
define("_PMSMSGDELETED", "Din meddelelse blev slettet.");
define("_PMSMSGDELETED2", "Dine meddelelser blev slettet.");
define("_PMSMSGNOTODELETE", "Der blev ikke valgt en meddelelse til sletning.");
define("_PMSCLICKSMILEBUTTONS", "Klik p en " . _PMSBBCODELINK . " smilie</a>, for at tilfje den meddelelsen:");
define("_PMSCLICKCODEBUTTONS", "Klik p knapperne, for " . _PMSBBCODELINK . " BBCode</a> tilfj din meddelelse.");
define("_PMSGERROR", "Fejl!");
define("_PMSUSERSLIST", "liste bruger");
define("_PMSONLINE", "online");
define("_PMSOFFLINE", "offline");
define("_PMSTIMESTRING", "%d.%m.%y %H:%M");
define("_PMSGOBACK", "tilbage");
define("_PMSDELETE", "slet meddelelse");
define("_ERRMSGDATABASE", "fejlmelding fra databasen.");
define("_ERRMSGNOUSER", "Du skal skrive en modtager. <br />G tilbage og indtast en modtager.");
define("_ERRMSGNOSUBJECT", "Du m poste til en tema. <br />Du kan ikke poste uden et tema. <br />G tilbage og vlg et tema.");
define("_ERRMSGNOHTMLINSUBJECT", "HTML er ikke tilladt i dette tema. <br />G tilbage for at ndre det.");
define("_ERRMSGNOICON", "u skal vlge et meddelelses-ikon. <br />G tilbage og vlg et ikon.");
define("_ERRMSGNOMESSAGE", "Du m skrive en meddelelse. <br />Du kan ikke sende uden at skrive en meddelelse. <br />G tilbage og ndre det.");
define("_ERRMSGNOSUBMIT", "Dataerne kan ikke overfres til databasen. <br />G tilbage og prv igen.");
define("_ERRMSGNODELETE", "Du kan ikke slette denne meddelelse.");

define("_PMNOSUBJECT", "Intet emne");
// Buddy:
define("_PMSPLSLOGIN", "logind frst");
define("_PMSTITLE", "PageMessenger");
define("_PMSDISCRIBE", "Her kan du udveksle meddelelser med andre brugere af $sitename-community. Principet baserer p alle gngse messenger, og du behver ikke at vre p $sitename!");
define("_PMSNOWON", "online nu");
define("_PMSALLUSERS", "alle brugere");
define("_PMSSENDM", "send en meddelelse til");
define("_PMSINCOME", "meddelelse fra");
define("_PMSREPLY", "svar");
define("_PMSCLOSE", "luk");
define("_PMSAUTOCLOSE", "Vinduet lukker automatisk");
define("_PMSSENDED1", "Meddelelsen blev sendt til ");
define("_PMSSENDED2", " sendt.");
define("_PMSBUDDYERROR", "Beklager, meddelelsen kunne ikke sendes.");
define("_PMSYUMPUP", "klik, for at g til toppen");
define("_PMSYUMPDOWN", "klik, for at g til bunden");
// PM-Erweiterung
define("_PMSDELETED", "Gelscht");
define("_PMSREAD", "Gelesen");
define("_SENTPMSTO", "An");
define("_SENTPMS", "Ihre gesendeten Nachrichten");
define("_SENTPMSDONTHAVESOME", "Sie haben zur Zeit keine gesendeten Nachrichten.");
define("_SAVEPMS", "Klicken Sie hier, um Ihre PMs als E-Mail zu sichern");
define("_PMSSAVE", "Kopie im Ausgang speichern?");
define("_NOTSAVEPMS", "(wenn Sie die Nachricht nicht speichern mchten, dann entfernen Sie den Haken)");
define("_YOURPMS", "Ihre PMs wurden Ihnen per Mail zugeschickt.");
define("_ASENTPMS", "zum Postausgang wechseln");
define("_ESENTPMS", "zum Posteingang wechseln");
define("_PMDEL", "markierte Nachrichten lschen");
define("_PMALL", "Alle");
define("_SAVEPMSS", "PMs sichern: ");
// PM per E-Mail
define("_PMSSI", "PM Sicherung");
define("_PMSBOX", "Ihre PM Box");
define("_TOPMS", "Am");
define("_ANPMS", " schrieben Sie an");
define("_AOPMS", "In Ihrem Ausgangsordner lagen folgende Nachrichten");
define("_SPMS", "schrieb");
// define("_HELLO", "Hallo");
define("_YOURMAILPMS", "Ihre Nachrichten per Mail an Ihre Adresse verschickt.");
define("_HPMS", "Hier sind sie nun");
define("_MFGPMS", "Mit freundlichen Grssen");
define("_PMEMAIL", "\nSie haben auf ");
define("_PMEMAIL1", " eine neue Nachricht von ");
define("_PMEMAIL2", "erhalten.\n
WICHTIG: Beachten Sie bitte, dass dies nur eine Benachrichtigung ist. Bitte antworten Sie nicht auf diese E-Mail.\n
Ihre Nachricht knnen Sie hier abholen:\n ");
define("_PMEMAIL3", "\n
=================================================================================
Wenn Sie nicht per Email ber neue PN's informiert werden wollen, knnen Sie die Option hier deaktivieren:\n");
define("_PMEMAILSUB", "Nachricht auf ");
// ignore
define("_NOMESSAGE", "mchte keine Nachrichten von Ihnen!");
/* PM Begrenzung */
define("_PMNE", "Nachrichten Eingang: ");
define("_PMNA", "Nachrichten Ausgang: ");
define("_EMPFPMBOXVOLL", "Das Postfach des Empfngers ist voll! Er kann zur Zeit keine neuen Nachrichten empfangen.");
define("_SENTPMBOXVOLL", "Ihre Box mit den gesendeten Nachrichten ist voll!<br />Bitte sichern und leeren!");
define("_GETPMBOXVOLL", "Ihr Posteingang ist voll! Bitte sichern und leeren!");
define("_PMNOCH", " noch ");
define("_PMVON", " von ");
define("_PMFREI", " frei ");
define("_PMIN", "Posteingang");
define("_PMOUT", "Postausgang");
define("_EMPFPMS", " Ihre empfangenen Nachrichten ");

?>
